#!/bin/sh

# How to use this:
# - put this in your ~/bin
# - symlink binaries to this, eg:
# ln -s ./runwithtitle.sh w3m 

cmd=`basename $0`

#set the screen title
# Escape all whitespace chars (\s : whitespace)
titletext=`echo "$cmd $@" | sed -e 's/\s/\\ /g'`

case $TERM in
    screen*)
        # Escape all whitespace chars (\s : whitespace)
        /usr/bin/screen -X title "$titletext"
        ;;
    tmux*)
        /usr/bin/tmux rename-window "$titletext"
        ;;
esac

/usr/bin/$cmd "$@"

case $TERM in
    tmux*)
        # Re-enable automatic renaming
        /usr/bin/tmux set-window-option automatic-rename on
        ;;
esac
